---
title: yield*
slug: Web/JavaScript/Reference/Operators/yield*
tags:
  - ECMAScript 2015
  - Generators
  - Iterable
  - Iterator
  - JavaScript
  - Language feature
  - Operator
  - Reference
---
<div>{{jsSidebar("Operators")}}</div>

<p><span class="seoSummary">The <strong><code>yield*</code> expression</strong> is used to delegate to another {{jsxref("Statements/function*", "generator")}} or iterable object.</span></p>

<div>{{EmbedInteractiveExample("pages/js/expressions-yieldasterisk.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"> yield* <var>expression</var>;</pre>

<dl>
 <dt><code><var>expression</var></code></dt>
 <dd>The expression which returns an iterable object.</dd>
</dl>

<h2 id="Description">Description</h2>

<p>The <code>yield*</code> expression iterates over the operand and <code>yield</code>s each value returned by it.</p>

<p>The value of <code>yield*</code> expression itself is the value returned by that iterator when it's closed (i.e., when <code>done</code> is <code>true</code>).</p>

<h2 id="Examples">Examples</h2>

<h3 id="Delegating_to_another_generator">Delegating to another generator</h3>

<p>In following code, values yielded by <code>g1()</code> are returned from <code>next()</code> calls just like those which are yielded by <code>g2()</code>.</p>

<pre class="brush: js">function* g1() {
  yield 2;
  yield 3;
  yield 4;
}

function* g2() {
  yield 1;
  yield* g1();
  yield 5;
}

const iterator = g2();

console.log(iterator.next()); // {value: 1, done: false}
console.log(iterator.next()); // {value: 2, done: false}
console.log(iterator.next()); // {value: 3, done: false}
console.log(iterator.next()); // {value: 4, done: false}
console.log(iterator.next()); // {value: 5, done: false}
console.log(iterator.next()); // {value: undefined, done: true}
</pre>

<h3 id="Other_Iterable_objects">Other Iterable objects</h3>

<p>Besides generator objects, <code>yield*</code> can also <code>yield</code> other kinds of iterables (e.g., arrays, strings, or {{jsxref("Functions/arguments", "arguments")}} objects).</p>

<pre class="brush: js">function* g3() {
  yield* [1, 2];
  yield* '34';
  yield* Array.from(arguments);
}

const iterator = g3(5, 6);

console.log(iterator.next()); // {value: 1, done: false}
console.log(iterator.next()); // {value: 2, done: false}
console.log(iterator.next()); // {value: "3", done: false}
console.log(iterator.next()); // {value: "4", done: false}
console.log(iterator.next()); // {value: 5, done: false}
console.log(iterator.next()); // {value: 6, done: false}
console.log(iterator.next()); // {value: undefined, done: true}
</pre>

<h3 id="The_value_of_yield*_expression_itself">The value of <code>yield*</code> expression itself</h3>

<p><code>yield*</code> is an expression, not a statement—so it evaluates to a value.</p>

<pre class="brush: js">function* g4() {
  yield* [1, 2, 3];
  return 'foo';
}

function* g5() {
  const g4ReturnValue = yield* g4();
  console.log(g4ReturnValue) // 'foo'
  return g4ReturnValue;
}

const iterator = g5();

console.log(iterator.next()); // {value: 1, done: false}
console.log(iterator.next()); // {value: 2, done: false}
console.log(iterator.next()); // {value: 3, done: false} done is false because g5 generator isn't finished, only g4
console.log(iterator.next()); // {value: 'foo', done: true}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-generator-function-definitions-runtime-semantics-evaluation', 'Yield')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.operators.yield_star")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/The_Iterator_protocol">The Iterator protocol</a></li>
 <li>{{jsxref("Statements/function*", "function*")}}</li>
 <li>{{jsxref("Operators/function*", "function* expression")}}</li>
 <li>{{jsxref("Operators/yield", "yield")}}</li>
</ul>
